<?php
/*
 * ----------------------------------------------------------------------------
 * Files-DispMsg.php                                                 02/20/2003
 * This script will display a list of messages that are available in the
 * selected database.
 * The variable $t is passed to the script to set the topic number.
 * The variable $d is passed to the script to set the database number.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2003 Steve Winn. All Rights Reserved.
 *
 * The source code contains a fair amount of comments, which may aid anyone
 * attempting to follow the program or to modify it.
 *
 * For licensing and copyright information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

require_once('va-functions.inc.php');       // A VADV-PHP script.
require_once('va-loginauth.inc.php');       // Login authentication.
require_once('va-database.inc.php');        // Include database functions.
require_once('layout_files.inc.php');       // Webpage footer and header.

ForumHeader();                              // Display the webpage header.

if (isset($_GET['t'])) {                    // Set the passed variables.
    $t = $_GET['t'];
} else {
    $t = 10;
}

if (isset($_GET['d'])) {                    // Set the passed variables.
    $d = $_GET['d'];
} else {
    $d = 1;
}

if ($t < 1) $t = 1;
if ($d < 1) $d = 1;

$topic = GetTopicInfo($t, 'F');             // Retrieve the topic information.
// If this is an invalid section, display an error message.
if (!$topic) die('<br><h3>Invalid topic. Please press the BACK button on your browser.</h3>');

$db = GetDBInfo($t, $d);                    // Retrieve the database information.
// Determine if the user has access to this section.
if (!DbAccess($db)) die('<br><h3>You do not have access to this section. Please press the BACK button on your browser.</h3>');

$msgno = $db['msgno'];                      // Retrieve the number of messages.

if (isset($_GET['m'])) {                    // Set the passed variables.
    $m = $_GET['m'];
} else {
    $m = $msgno;
}
if ($m > $msgno) $m = $msgno;

// Setup the previous/next links.
if ($m > 25) {
    $num = $m - 25;
    $cnt = 25;
    if ($num < 25) $cnt = $num;
    print "      <span class=\"msgBack\"><a class=\"msgBack\" href=\"files-dispmsg.php?t=" . $t . "&d=" . $d . "&m=" . $num . "\">Previous " . $cnt . "</a> |</span>\n";
}

if ($m < $msgno) {
    $num = $m + 25;
    if ($num > $msgno) $num = $msgno;
    $cnt = 25;
    if (($msgno - $m) < 25) $cnt = ($msgno - $m);
    print "      <span class=\"msgBack\"><a class=\"msgBack\" href=\"files-dispmsg.php?t=" . $t . "&d=" . $d . "&m=" . $num . "\">Next " . $cnt . "</a> |</span>\n";
}
print "      <span class=\"msgBack\"><a class=\"msgBack\" href=\"files-dispdb.php?t=" . $t . "\">Back to " . htmlspecialchars($topic['desc']) . "</a></span><br>\n";
?>

<table border="1" width="750" cellspacing="0" cellpadding="2" bordercolor="#666666" style="border-collapse: collapse">
    <tr>
        <td colspan="5" bgcolor="#416DBF" height="25" width="748">
            <span class="msgTitle">&nbsp;&nbsp;<?php print htmlspecialchars($db['desc']); ?></span></td>
    </tr>
    <tr>
        <td width="30" height="15" bgcolor="#000080"></td>
        <td width="385" height="15" bgcolor="#000080" align="left">
            <span class="msgHeader">&nbsp;Description</span></td>
        <td width="100" height="15" bgcolor="#000080" align="center">
            <span class="msgHeader">&nbsp;Filename</span></td>
        <td width="60" height="15" bgcolor="#000080" align="center">
            <span class="msgHeader">&nbsp;Size</span></td>
        <td width="175" height="15" bgcolor="#000080" align="center">
            <span class="msgHeader">Date/Time/Uploader</span></td>
    </tr>

<?php
// Set the fileString variable.
$file    = $VA_SYSPATHS['db'] . "\\" . $db['filename'] . '.DAT';
if (!is_file($file)) die('Requested database is missing. Please press the BACK button on your browser.');
$fileString = ReadCfgFile($file);    // Read the file.

// Run the loop that will display the messages.
for ($x = $m; $x >= ($m - 24); $x--) {
    if ($x <= 0) break;
    $msgInfo = FindMessageInfo($db, $x, $fileString);   // Get the message information.
    $dateTime = ConvertDateTime($msgInfo['date'], $msgInfo['time']);

    if ($msgInfo['fromhandle'] == '') {
        $from = 'Unknown';
    } else {
        $from = htmlspecialchars($msgInfo['fromhandle']);
    }

    if ($msgInfo['subject'] == '') {
        $subject = 'No Subject';
    } else {
        $subject = htmlspecialchars($msgInfo['subject']);
    }

    if ($msgInfo['attfilename'] != '') {
        if ($CONFIG['filehost'] != '') {
            $file = ConvertDir($CONFIG['hostname'], $db['filepath']) . "\\" . $msgInfo['attfilename'];
        } else {
            $file = $db['filepath'] . "\\" . $msgInfo['attfilename'];
        }
    } else {
        $file = '';
    }

if ($file != '') {
    if (!is_file($file)) {
        $filesize = '0 bytes';
    } else {
        $filesize = filesize($file);
        if ($filesize >= 1024000) {
            $filesize = round($filesize / 1048576, 1) . 'MB';
        } elseif ($filesize >= 1024) {
            $filesize = intval($filesize / 1024) . 'KB';
        } else {
            $filesize = $filesize . ' bytes';
        }
    }
}
?>

    <tr>
        <td width="30" height="30" bgcolor="#E2E2E2" align="center">
            <img border="0" src="images/message.gif" alt="Message" width="13" height="11"><?php if ($msgInfo['attfilename'] != '') print "<img border=\"0\" src=\"images/paperclip.gif\" alt=\"Attached File\" width=\"10\" height=\"13\">"; ?></td>
        <td width="385" height="30" align="left">
            <span class="heading">&nbsp;<a href="files-viewmsg.php?t=<?php print $t . "&d=" . $d . "&m=" . $x . "\">" . $subject; ?></a></span></td>
        <td width="100" height="30" bgcolor="#E2E2E2" align="center">
            <span class="boldBody"><?php print htmlspecialchars($msgInfo['attfilename']); ?></span></td>
        <td width="60" height="30" align="center">
            <span class="body"><?php print $filesize; ?></span></td>
        <td width="175" height="30" bgcolor="#E2E2E2" align="center">
            <span class="body"><?php print $dateTime['date']; ?></span><span class="msgTime">&nbsp;<?php print $dateTime['time']; ?></span><br><span class="body">by </span><span class="boldBody"><?php print $from; ?></span></td>
    </tr>

<?php
}
?>

    <tr>
        <td bgcolor="#416DBF" align="center" colspan="5" height="25" width="748">&nbsp;</td>
    </tr>
</table>

<?php
// Setup the previous/next links.
if ($m > 25) {
    $num = $m - 25;
    $cnt = 25;
    if ($num < 25) $cnt = $num;
    print "      <span class=\"msgBack\"><a class=\"msgBack\" href=\"files-dispmsg.php?t=" . $t . "&d=" . $d . "&m=" . $num . "\">Previous " . $cnt . "</a> |</span>\n";
}
if ($m < $msgno) {
    $num = $m + 25;
    if ($num > $msgno) $num = $msgno;
    $cnt = 25;
    if (($msgno - $m) < 25) $cnt = ($msgno - $m);
    print "      <span class=\"msgBack\"><a class=\"msgBack\" href=\"files-dispmsg.php?t=" . $t . "&d=" . $d . "&m=" . $num . "\">Next " . $cnt . "</a> |</span>\n";
}
print "      <span class=\"msgBack\"><a class=\"msgBack\" href=\"files-dispdb.php?t=" . $t . "\">Back to " . htmlspecialchars($topic['desc']) . "</a></span><br>\n";

$totalTime = round(ProgramTime() - $startTime, 4);

ForumFooter();                              // Display the webpage footer.
?>
